#Xarxa neuronal per a la detecció de bucles en visualSLAM
Aquest projecte crea i avalua una xarxa neuronal per a la detecció de bucles en visualSLAM.

L'arquitectura de la xarxa neuronal parteix de la base introduida per N. Merril i G. Huang a [_Lightweight Unsupervised Deep Loop Closure_](https://arxiv.org/abs/1805.07703).

##Llibreries emprades
A continuació mostrem la versió de Python usada així com de les principals llibreries:
* Python 3.6.7
* numpy 1.14.6
* keras 2.2.4
* matplotlib 3.0.3
* plaidml 0.7.0 `opcional`

##Arquitectura de l'aplicació
Els arxius continguts en aquest projecte es divideixen en:
 * Arxiu d'execució principal: `test`.
 * Arxius que defineixen l'arquitectura de la xarxa neuronal: `neural_network` i `model**`. (**hi han diversos models analitzats).
 * Arxius de gestió del conjunt de dades: `dataset` i `data_generator`.
 * Arxius d'utilitats: `transform2d`, `neural_network_utils`, `neural_network_eval`, `motionestimator`, `model_utils`, `imagematcher` i `data_generator_utils`. 

###Execució principal
>La llibreria `plaidml` és **opcional**. Permet usar GPU en l'entrenament de la xarxa neuronal. Si no es vol emprar aquesta llibreria, s'ha d'eliminar les següent línies del codi en `test.py`:
>````
>import plaidml.keras
>plaidml.keras.install_backend()```
>
L'arxiu `test` permet crear una xarxa neuronal i avaluar-la.
Per fer-ho té els següent mètodes:
 * `test_model`: crea una xarxa neuronal, l'emmagatzema al directori d'execució i dibuixa gràfics de pèrdua de l'entrenament.
 * `eval_model`: carrega una xarxa neuronal. Calcula grau d'encert de la xarxa, calcula la matriu de confusió i realitza altres proves.
 * `check_one_query`: analitza tots els models guardats al directori d'execució per avaluar el grau d'aproximació al tancament esperat.

##Informació d'autoria 
Aquest projecte pertany al Treball Final de Màster de Jordi Gálvez Santos al Màster d'Enginyeria Informàtica de la Universitat Oberta de Catalunya.  
 
Aquest codi usa llibreries proporcionades per Antoni Burguera (antoni dot burguera at uib dot es)



