import keras.backend as K


def euclidean_distance_loss(y_true, y_pred):
    """ Euclidean distance loss
        Més informació a https://en.wikipedia.org/wiki/Euclidean_distance o
        https://riptutorial.com/keras/example/32022/euclidean-distance-loss

        Args:
            :param y_true: TensorFlow/Theano tensor
            :param y_pred: TensorFlow/Theano tensor of the same shape as y_true

        Returns:
            :return: float
    """

    # coffe hace "the sum of squares of differences", https://caffe.berkeleyvision.org/tutorial/layers/euclideanloss.html
    # coffe euclidean loss layer == L2 layer, http://caffe.berkeleyvision.org/doxygen/classcaffe_1_1EuclideanLossLayer.html

    # Keras https://github.com/keras-team/keras/blob/master/keras/losses.py
    # K.mean(K.square(y_pred - y_true), axis=-1)
    return K.sqrt(K.sum(K.square(y_pred - y_true), axis=-1))