from keras import backend as K
from keras.layers import Activation
from keras.utils.generic_utils import get_custom_objects


# needs to be defined as activation class otherwise error
# AttributeError: 'Activation' object has no attribute '__name__'
class Swish(Activation):

    def __init__(self, activation, **kwargs):
        super(Swish, self).__init__(activation, **kwargs)
        self.__name__ = 'swish'


def swish(x, beta=1):
    return K.sigmoid(beta * x) * x


get_custom_objects().update({'swish': Swish(swish)})
